#include "NavierStokesPoiseuille.hpp"

#include "Cell.hpp"

inline double sqr(double d) { return d * d; }

IACoefficients NavierStokesPoiseuille::B4Coefficients_U(const Cell &c) const {
  IAInterval a1(c[0][1]);
  IAInterval b1(c[1][1]);
  IAInterval c1(c[2][1]);
  return IACoefficients{
      a1 * (1 - a1),
      -sqr(a1) / 2 + (3 - 2 * b1) * a1 / 4 + b1 / 4,
      -sqr(a1) / 2 + (3 - 2 * c1) * a1 / 4 + c1 / 4,
      -sqr(a1) / 6 + (3 - 4 * b1) * a1 / 6 - sqr(b1) / 6 + b1 / 2,
      -sqr(a1) / 6 + (6 - 4 * b1 - 4 * c1) * a1 / 12 + (3 - 2 * c1) * b1 / 12 + c1 / 4,
      -sqr(a1) / 6 + (3 - 4 * c1) * a1 / 6 - sqr(c1) / 6 + c1 / 2,
      -sqr(b1) / 2 + (3 - 2 * a1) * b1 / 4 + a1 / 4,
      -sqr(b1) / 6 + (6 - 4 * a1 - 4 * c1) * b1 / 12 + (3 - 2 * c1) * a1 / 12 + c1 / 4,
      -sqr(c1) / 6 + (6 - 4 * a1 - 4 * b1) * c1 / 12 + (3 - 2 * b1) * a1 / 12 + b1 / 4,
      -sqr(c1) / 2 + (3 - 2 * a1) * c1 / 4 + a1 / 4,
      b1 * (1 - b1),
      -sqr(b1) / 2 + (3 - 2 * c1) * b1 / 4 + c1 / 4,
      -sqr(b1) / 6 + (3 - 4 * c1) * b1 / 6 - sqr(c1) / 6 + c1 / 2,
      -sqr(c1) / 2 + (3 - 2 * b1) * c1 / 4 + b1 / 4,
      c1 * (1 - c1)
  };
}

IACoefficients NavierStokesPoiseuille::B9Coefficients_U(const Cell &c) const {
  IAInterval a1(c[0][1]);
  IAInterval b1(c[1][1]);
  IAInterval c1(c[2][1]);
  IAInterval A1 = sqr(a1);
  IAInterval B1 = sqr(b1);
  IAInterval C1 = sqr(c1);
  return IACoefficients{
      a1 * (1 - a1),
      ((8 - 7*a1 - 2*b1)*a1 + b1) / 9,
      ((8 - 7*a1 - 2*c1)*a1 + c1) / 9,
      ((8-b1 -14*a1)*b1/4 + 7*a1*(1 - 3*a1/4)) / 9,
      ((7*(4-3*a1-b1-c1)*a1 + (4-c1)*b1)/4 + c1) / 9,
      ((8-c1 -14*a1)*c1/4 + 7*a1*(1 - 3*a1/4)) / 9,
      (((8-5*a1-6*b1)*a1 - B1) / 4 + b1) / 3,
      ((-5*A1 + (6*(4-2*b1-c1)*a1 - B1 + 2*(4-c1)*b1) / 3) / 4 + c1/3) / 3,
      ((-5*A1 + (6*(4-b1-2*c1)*a1 - C1 + 2*(4-b1)*c1) / 3) / 4 + b1/3) / 3,
      (((8-5*a1-6*c1)*a1 - C1) / 4 + c1) / 3,
      (-B1/2 + (((8-10*a1)*b1 - 5*A1) / 2 + 5*a1) / 3) / 3,
      (-B1/4 + ((-5*A1 + (5*(4-3*b1-c1)*a1 + 3*(4-c1)*b1) / 2) / 2 + c1) / 3) / 3,
      ((-5*A1 + 5*(2-b1-c1)*a1 + 2*(2-c1)*b1 - (C1+B1) / 2) / 2 + 2*c1) / 9,
      (-C1/4 + ((-5*A1 + (5*(4-b1-3*c1)*a1 + 3*(4-b1)*c1) / 2) / 2 + b1) / 3) / 3,
      (-C1/2 + (((8-10*a1)*c1 - 5*A1) / 2 + 5*a1) / 3) / 3,
      (((-5*B1 + 10*(1-a1)*b1) / 2 + 4*a1) / 3 - A1/2) / 3,
      (-(A1+B1)/2 + ((4-4*b1-c1)*a1 + (4-c1)*b1 + c1) / 3) / 3,
      (-A1/2 - B1/4 + ((4*(4-3*b1-2*c1)*a1 + 3*(4-2*c1)*b1 - C1) / 4 + 2*c1) / 3) / 3,
      (-A1/2 - C1/4+ (4*(4-2*b1-3*c1)*a1 - B1 + 2*(4-3*c1)*b1)/12 + c1) / 3,
      (-(A1+C1)/2 + ((4-b1-4*c1)*a1 + (4-b1)*c1 + b1) / 3) / 3,
      (((-5*C1 + 10*(1-a1)*c1) / 2 + 4*a1) / 3 - A1/2) / 3,
      ((-A1 + (-6*b1+4)*a1 - 5*B1) / 4 + 2*b1) / 3,
      (-A1/4 + (((3*(4-5*b1-c1)*a1 + 5*(4-c1)*b1) / 2 - 5*B1) / 2 + c1) / 3) / 3,
      (-B1/2 - A1/4 + ((6*(2-2*b1-c1)*a1 + 4*(4-2*c1)*b1 - C1) / 4 + 2*c1) / 3) / 3,
      ((-A1 - B1 - C1+ (4-3*b1-3*c1)*a1  + (4-3*c1)*b1) / 4 + c1) / 3,
      (-C1/2 - A1/4 + ((6*(2-b1-2*c1)*a1 - B1 + 8*(1-c1)*b1) / 4 + 4*c1) / 3) / 3,
      (-A1/4 + (((3*(4-b1-5*c1)*a1 + 5*(4-b1)*c1) / 2 - 5*C1) / 2 + b1) / 3) / 3,
      ((-A1 + (-6*c1+4)*a1 - 5*C1) / 4 + 2*c1) / 3,
      ((8-a1 -14*b1)*a1/4 + 7*b1*(1 - 3*b1/4)) / 9,
      (((-A1 + 2*(4-6*b1-c1)*a1 + 6*(4-c1)*b1) / 3 - 5*B1) / 4 + c1/3) / 3,
      (((-A1 + 2*(4-5*b1-2*c1)*a1 + 10*(2-c1)*b1 - C1) / 2 - 5*B1) / 2 + 2*c1) / 9,
      (-B1/2 + ((-A1 + 2*(4-4*b1-3*c1)*a1) / 4 + (4-3*c1)*b1) / 3 - C1/4 + c1) / 3,
      (-C1/2 - B1/4 + ((-A1 + (8-6*b1-8*c1)*a1) / 4 + 4*c1) / 3 + (1-c1)*b1) / 3,
      ((-(A1 + B1) / 2 + (4-5*c1)*b1 + (4-2*b1-5*c1)*a1 - 5*C1) / 2 + 5*c1) / 9,
      ((-5*C1 + (-A1 + 2*(4-b1-6*c1)*a1 + 6*(4-b1)*c1) / 3) / 4 + b1/3) / 3,
      ((8-a1 -14*c1)*a1/4 + 7*c1*(1 - 3*c1/4)) / 9,
      ((8 - 7*b1 - 2*a1)*b1 + a1) / 9,
      ((-7*B1 + (7*(4-a1-c1)*b1 + (4-c1)*a1) / 3) / 4 + c1/3) / 3,
      ((-5*B1 + (6*(4-a1-2*c1)*b1 - C1 + 2*(4-a1)*c1) / 3) / 4 + a1/3) / 3,
      (-C1/4 + ((-5*B1 + (5*(4-a1-3*c1)*b1  + 3*(4-a1)*c1) / 2) / 2 + a1) / 3) / 3,
      (-(B1+C1) / 2 + ((4-a1-4*c1)*b1 + (4-a1)*c1 + a1) / 3) / 3,
      (-B1/4 + (((3*(4-a1-5*c1)*b1 + 5*(4-a1)*c1) / 2 - 5*C1) / 2 + a1) / 3) / 3,
      (((-B1 + 2*(4-a1-6*c1)*b1 + 6*(4-a1)*c1) / 3 - 5*C1) / 4 + a1/3) / 3,
      ((-7*C1 + (7*(4-a1-b1)*c1 + (4-b1)*a1) / 3) / 4 + b1/3) / 3,
      ((8 - 7*c1 - 2*a1)*c1 + a1) / 9,
      b1 * (1 - b1),
      ((8 - 7*b1 - 2*c1)*b1 + c1) / 9,
      ((8-c1 -14*b1)*c1/4 + 7*b1*(1 - 3*b1/4)) / 9,
      (((8-5*b1-6*c1)*b1 - C1) / 4 + c1) / 3,
      (-C1/2 + (((- 10*b1  + 8)*c1 - 5*B1) / 2 + 5*b1) / 3) / 3,
      (((-5*C1 + (-10*b1  + 10)*c1) / 2 + 4*b1) / 3 - B1/2) / 3,
      ((-B1 + (- 6*c1  + 4)*b1 - 5*C1) / 4 + 2*c1) / 3,
      ((8-b1 -14*c1)*b1/4 + 7*c1*(1 - 3*c1/4)) / 9,
      ((8 - 7*c1 - 2*b1)*c1 + b1) / 9,
      c1 * (1 - c1)
  };
}

IACoefficients NavierStokesPoiseuille::B3Coefficients_DU(const Cell &c) const {
  IAInterval a1(c[0][1]);
  IAInterval b1(c[1][1]);
  IAInterval c1(c[2][1]);
  return IACoefficients{
      1 - 2 * a1,
      1 - 2 * (b1 + 2 * a1) / 3,
      1 - 2 * (c1 + 2 * a1) / 3,
      1 - 2 * (a1 + 2 * b1) / 3,
      1 - 2 * (a1 + b1 + c1) / 3,
      1 - 2 * (a1 + 2 * c1) / 3,
      1 - 2 * b1,
      1 - 2 * (c1 + 2 * b1) / 3,
      1 - 2 * (b1 + 2 * c1) / 3,
      1 - 2 * c1
  };
}

IACoefficients NavierStokesPoiseuille::B8Coefficients_DU(const Cell &c) const {
  IAInterval a1(c[0][1]);
  IAInterval b1(c[1][1]);
  IAInterval c1(c[2][1]);
  return IACoefficients{
      1 - 2 * a1,
      1 - (7 * a1 + b1) / 4,
      1 - (7 * a1 + c1) / 4,
      1 - (3 * a1 + b1) / 2,
      1 - (3 * a1 + (b1 + c1) / 2) / 2,
      1 - (3 * a1 + c1) / 2,
      1 - (5 * a1 + 3 * b1) / 4,
      1 - (b1 + (5 * a1 + c1) / 2) / 2,
      1 - (c1 + (5 * a1 + b1) / 2) / 2,
      1 - (5 * a1 + 3 * c1) / 4,
      1 - a1 - b1,
      1 - a1 - (3 * b1 + c1) / 4,
      1 - a1 - (b1 + c1) / 2,
      1 - a1 - (b1 + 3 * c1) / 4,
      1 - a1 - c1,
      1 - (3 * a1 + 5 * b1) / 4,
      1 - b1 - (3 * a1 + c1) / 4,
      1 - (c1 + 3 * (a1 + b1) / 2) / 2,
      1 - (b1 + 3 * (a1 + c1) / 2) / 2,
      1 - c1 - (3 * a1 + b1) / 4,
      1 - (3 * a1 + 5 * c1) / 4,
      1 - (a1 + 3 * b1) / 2,
      1 - (a1 + (5 * b1 + c1) / 2) / 2,
      1 - b1 - (a1 + c1) / 2,
      1 - (a1 + 3 * (b1 + c1) / 2) / 2,
      1 - c1 - (a1 + b1) / 2,
      1 - (a1 + (b1 + 5 * c1) / 2) / 2,
      1 - (a1 + 3 * c1) / 2,
      1 - (a1 + 7 * b1) / 4,
      1 - (3 * b1 + (a1 + c1) / 2) / 2,
      1 - (c1 + (a1 + 5 * b1) / 2) / 2,
      1 - b1 - (a1 + 3 * c1) / 4,
      1 - c1 - (a1 + 3 * b1) / 4,
      1 - (b1 + (a1 + 5 * c1) / 2) / 2,
      1 - (3 * c1 + (a1 + b1) / 2) / 2,
      1 - (a1 + 7 * c1) / 4,
      1 - 2 * b1,
      1 - (7 * b1 + c1) / 4,
      1 - (3 * b1 + c1) / 2,
      1 - (5 * b1 + 3 * c1) / 4,
      1 - b1 - c1,
      1 - (3 * b1 + 5 * c1) / 4,
      1 - (b1 + 3 * c1) / 2,
      1 - (b1 + 7 * c1) / 4,
      1 - 2 * c1
  };
}